#include <xc.h>
#include <plib.h>
#include "vardef.h"
#include "functions.h"
#include "Uart.h"
//#include "HardwareProfile.h"

//!------------------------------------------------------------------------------
//!	@caution	Configuration bits ӓ_ on PIC32MX 1XX/2XX
//!				`ȂƃftHgONŁAIO|[g\񂳂Ă܂
//!				FUSBIDIO	B5	ftHgUSBIDŎg
//!				FSOSCEN		B4, A4	ftHgZJ_IV[^pƂȂ
//!				JTAGEN		B5,7,8,9 ftHgJTAGpɂȂ
//!------------------------------------------------------------------------------
// DEVCFG3
// USERID = No Setting
#pragma config PMDL1WAY = OFF            // Peripheral Module Disable Configuration (Allow only one reconfiguration)
#pragma config IOL1WAY = OFF             // Peripheral Pin Select Configuration (Allow only one reconfiguration)
#pragma config FUSBIDIO = OFF            // USB USID USBȊO̗prƂ(OFF)
#pragma config FVBUSONIO = OFF           // USB VBUS ON Selection (Controlled by USB Module)

// DEVCFG2
#pragma config FPLLIDIV = DIV_5         // PLL Input Divider (2x Divider)
#pragma config FPLLMUL = MUL_20         // PLL Multiplier (20x Multiplier)
#pragma config UPLLIDIV = DIV_5         // USB PLL Input Divider (2x Divider)
#pragma config FPLLODIV = DIV_2     // PLL Output Divider: 80 / 2 = 40
#pragma config UPLLEN = OFF             // USB PLL Enable (Enabled)

// DEVCFG1
#pragma config FNOSC = PRIPLL           // Oscillator Selection Bits (Fast RC Osc with PLL)
#pragma config FSOSCEN = OFF            // Secondary Oscillator Enable (Disabled)
#pragma config IESO = OFF               // Internal/External Switch Over (Disabled)
#pragma config POSCMOD = HS             // Primary Oscillator Configuration (HS osc mode)
#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Disabled)
#pragma config FPBDIV = DIV_1           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/1)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable (Watchdog Timer is in Non-Window Mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (WDT Disabled (SWDTEN Bit Controls))
#pragma config FWDTWINSZ = WINSZ_25     // Watchdog Timer Window Size (Window Size is 25%)

// DEVCFG0
#pragma config JTAGEN = OFF             // JTAG Enable (JTAG Port Enabled)
#pragma config ICESEL = ICS_PGx3        // ICE/ICD Comm Channel Select (Communicate on PGEC1/PGED1)
#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Enabled)
#pragma config CP = OFF                 // Code Protect (Protection Disabled)

//---------------------- ϐCX^X̒`
#if 1
volatile char gIsRunning;
volatile int gnAliveCnt;		// 0.1bŉZANNpX_m0NAŉ]Ɏg
volatile DWORD gnTimer2Cnt;	// Timer2荞݂Ƃ̃JEg,0.1b
//volatile int gn100msCnt;
volatile int gnTimer1Mode;
volatile int gnTimer4Mode;
volatile int gnInjStopPeriod;
volatile int gninjststartwait;
volatile int gninjststartangle;
volatile int gnIgnStartAngle;
volatile int gnIgnStopAngle;
volatile int gnignstoppreiod;
volatile int gnignstartwait;
unsigned char gadresult[4000];
volatile int gidxadresult;
volatile int groundtime;		// 1]̃^C}[l
volatile DWORD glastCPTimes[32];
volatile int gIsInputCycle;	// ݂zCTCNǂ
volatile int gidxrpm;
volatile int gnrpm;
volatile int gnanglenow;		// NNpX݈̌ʒuA30xPʂ
volatile int gCPlusOn;			// ݁ANNpX
volatile int gOInjOn;			// ݁AIWiCWFN^[ON̏ꍇP
volatile int gnOInjStopPeriod; // IWiCWFN^ ON->OFF܂ł̃^C
volatile int gOIgnOn;			// ݁AIWiIGNON̏ꍇ1
volatile int gnOignstoppreiod; // IWiIGN ON->OFF܂ł̃^C
//volatile int gADOkayBank;		// ADϊĂoN 1 or 2, 0ȂAD,  rbgZ4 Ȃ΃oNPbN, 8Ȃ2bN
volatile char gOInjEnter;		// IWiCWFN^[2]ONɂȂƂ邩
volatile char gOIgnEnter;		// IWiIGN2]ONɂȂƂ邩
volatile int gErrorCode = EC_NOERROR;		// O[oG[R[h
ALLTBL gecudata;
UINT8 gIdxTbls[4][256];		// 臒l8rbgȂ̂ŁAYɕϊł悤e[u
volatile int gValVcc12;		// 12VdĎp
volatile int gValAccel;		// 255 - min
volatile int gValVaccum;
volatile int gValO2;
volatile int gValTemp1;
volatile int gValTemp2;
volatile int gScopeTarget;
volatile int gScopeDataAmount;
volatile int gnLastBTDC;		// BTDC_ΊpxA0.1xP
volatile int gnAccelDelta;
volatile int gnKasokuAdd;		// ɒǉ鑝ʁB{lɑ΂p[Ze[WA0.1%P
volatile int gnKasokuSubVal;	// gnKasokuAdd 0.1bɌZl
volatile int gnAccelPumpSpan;
volatile int gIGNON;
volatile int gINJON;
volatile DWORD  guINJDeadtime = GetTCntFrom10usec(DEFINJ_DEADTIME);

SAVEDATA gsavedata; //  
ALLTBL deftable;
volatile int gerror = 0;
#endif

//------------------------------------------- ftHgf[^̃e[u
ALLTBL deftable __attribute__ ((space(prog), aligned(1024))) =
{
	{},
	{},	// VACCUM臒l
	{},	//2
	{}, //3
	{}, //4
	{219, 201, 178, 153, 127, 103, 82, 64, 50, 39, 31, 24, 19, 15, 12, 9},	// T[~X^臒l
	{}, //5
	{219, 201, 178, 153, 127, 103, 82, 64, 50, 39, 31, 24, 19, 15, 12, 9},

};

void InitializeSystem()
{
	UINT pbClk;
	OSCCONbits.SOSCEN = 0; 
	pbClk =	SYSTEMConfigPerformance(GetSystemClock());
    INTEnableSystemMultiVectoredInt(); // Interrupt vectoring

	// AiO|[g͂
	TRISASET = (_PORTA_RA0_MASK | _PORTA_RA1_MASK | _PORTA_RA4_MASK);
	TRISBSET = (_TRISB_TRISB0_MASK | _TRISB_TRISB1_MASK |_TRISB_TRISB2_MASK | _TRISB_TRISB3_MASK | 
				_TRISB_TRISB4_MASK | _TRISB_TRISB5_MASK | _TRISB_TRISB11_MASK);
	// ̑o͂
	TRISBCLR = (_TRISB_TRISB7_MASK | _TRISB_TRISB8_MASK | _TRISB_TRISB9_MASK | _TRISB_TRISB10_MASK |
			    _TRISB_TRISB13_MASK | _TRISB_TRISB14_MASK | _TRISB_TRISB15_MASK);
	// UART@gpPINvAbvĂ݂
	CNPUBbits.CNPUB11 = 1;
	CNPUBbits.CNPUB14 = 1;

	// ɏo͂Itɂׂ̂ItɂĂ
	//LATB = 0;
	led1_off();
	INJ_off();
	IGN_off();
	MTR1_LO();
	MTR2_LO();
	
	// ϐ
	InitVars(); 

	// ADRo[^ZbgAbv
	ANSELA = 0x03;				// A0, A1̓AiO for sensor
	ANSELB = 0x0f;				// B0 - B3 AiOAfor sensor
	AD1CON2bits.CSCNA = 1;
	AD1CSSL = 0x3f;				// AN0 - AN5 ܂łUXL[hɂ
//	AD1CON2bits.BUFM = 1;		// QoNobt@g
	AD1CON2bits.BUFM = 0;		// QoNobt@gȂ
	AD1CON2bits.SMPI = 5;		// 荞݂ƂɂUTvO(n + 1)
	// 0.1msPʂŃTvOłΏ\ŁA6̂ 60ksps Ƃɂ 
	// AiOƂ̎ԂU = (32() * (12 + 8) * 25ns) x 6  0.0001 = 0.1ms
	AD1CON3bits.SAMC = 8;		// TAD = 8, 
	AD1CON3bits.ADCS = 15;		// (15 + 1) * 2 = 32  
	AD1CON1bits.ASAM = 1;		// TvO
	AD1CON1bits.SSRC = 7;		// gK
	AD1CON1bits.ON = 1;			// ADϊW[ON

	mAD1ClearIntFlag();
	mAD1SetIntPriority(1);		// Dx
	// 荞݂g킸AKvȒl͒擾
//	mAD1IntEnable(1);
	mAD1IntEnable(0);
	gidxadresult = 0;
	

	// NNpXM荞݂ŏ
	TRISBbits.TRISB4 = 1;
	//!!! InputCapture4IC4BUFlԂȂBDMAƕpłȂƔfBIC1OKIC3mF
//    IC4R = 0x02;                   // ͊荞݂RB4ATC;
//    mIC4ClearIntFlag();
//    mIC4SetIntPriority(5);			// 
//    mIC4IntEnable(1);
//	OpenCapture4(IC_ON | IC_FEDGE_RISE | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_EVERY_EDGE);

	INT4R = 2;						// ͊荞݂悤RB4ATC;
    mINT4SetEdgeMode(1);			// HIŊ荞
    mINT4ClearIntFlag();
    mINT4SetIntPriority(5);
    mINT4IntEnable(1);
	

	// IWĩCWFN^[ˊԊup
	TRISAbits.TRISA4 = 1;
	INT2R = 2;						// ͊荞݂悤RA4ATC;
    mINT2SetEdgeMode(INJON);		// CWFN^[ONŊ荞
    mINT2ClearIntFlag();
    mINT2SetIntPriority(3);
 //   mINT2IntEnable(1);
	
	// IWĩCOiC^Ԋup
	TRISBbits.TRISB5 = 1;
    INT3R = 1;						// ͊荞݂RB5ATC;
    mINT3SetEdgeMode(IGNON);		// COiC^[ONŊ荞
    mINT3ClearIntFlag();
    mINT3SetIntPriority(3);
//	mINT3IntEnable(1);
	
	//@GW쒆Timer2荞ݖɉZϐ̓NNpX̃X^[gn_
	// Zbg邽߂ɁAϐlȏ̏ꍇ͒~ĂƔfB
//	OpenTimer2( T2_ON | T2_PS_1_256 | T2_SOURCE_INT, WAIT100MS_SYSCLK);	// 0.1bԊuŊ荞ޒx
	mT2SetIntPriority(6);	//̊荞݂ƂDx
	mT2ClearIntFlag();
	mT2IntEnable(1);

//	mT3SetIntPriority(5);
//	mT3ClearIntFlag();
//	mT3IntEnable(3);
//	OpenTimer3( T3_ON | T3_PS_1_8 | T3_SOURCE_INT, WAIT10NS_8DIVCLK);	
	
	
	// Timer4A1Vbg^C}[ƂĎgB
	mT4IntEnable(1);
	mT4SetIntPriority(5);
//	OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, 0xffff);	

	mT1IntEnable(1);
	mT1SetIntPriority(5);
//	OpenTimer1( T1_ON | T1_PS_1_256 | T1_SOURCE_INT, 0xffff);	

	// DMA̐ݒBUART]Ŏg
	INTSetVectorPriority(INT_DMA_0_VECTOR, INT_PRIORITY_LEVEL_1); 
	INTSetVectorSubPriority(INT_DMA_0_VECTOR, INT_SUB_PRIORITY_LEVEL_3); 
	INTEnable(INT_SOURCE_DMA(DMA_CHANNEL0), INT_DISABLED);
	DmaChnOpen(DMA_CHANNEL0, 3, DMA_OPEN_AUTO); // auto repeat
	DmaChnWriteEventControlFlags(DMA_CHANNEL0, DMA_EV_START_IRQ(_UART2_TX_IRQ));
	DmaChnSetEvEnableFlags(DMA_CHANNEL0, DMA_EV_BLOCK_DONE | DMA_EV_ERR);
  
	//UARTI[v
	UartInit(pbClk);
	
	// [U[f[^[h
	{
		char	IsDefault = 0;
		memcpy(&gsavedata, ((void *)UDATA_FLASH_ADDRESS), sizeof(SAVEDATA));
		if (gsavedata.verifysign1 == 0xffffffff && gsavedata.verifysign2 == 0xffffffff)
		{
			// ftHgo[[h
			gsavedata.verifysign1 = 0;
			gsavedata.verifysign2 = 0;
			gsavedata.defIgnSpan = 640;
			gsavedata.defInjSpan = 330;			// 3.3ms
			gsavedata.ncurrent = 0;
			gsavedata.defBTDCFireVal = 120;		// BTDC12x
			gsavedata.naccelmin = 0;
			gsavedata.naccelmax = 0x3ff;
			gsavedata.IsUseAccelPump = 0;
			gsavedata.nAccelPumpSpan = 30;
			gsavedata.IsTunnelMode = 1;
			gsavedata.isUseVacSensor = 0;
			gsavedata.filler0 = 0;
			gsavedata. nInjDeadTime = DEFINJ_DEADTIME;					// CWFN^[̖
			gsavedata.nTDCOffset = 60;

			UpdateUdata(&gsavedata);
			IsDefault = 1;
		}
		else
		{
			if(gsavedata.ncurrent < 0 || gsavedata.ncurrent > 1)
				gsavedata.ncurrent = 0;
		}

		// ecue[u[h
		if(IsDefault)								// ftHglݒ
		{
			int		i;
			short	*parray = (short *)&gecudata.TBL02_data[0][0];
			char	*pcarray = (char *)&gecudata.TBL03_data[0][0];
			for( i = 0 ; i < sizeof(gecudata.TBL02_data) / sizeof(short); i++)
				parray[i] = 1000;
			for( i = 0 ; i < sizeof(gecudata.TBL03_data) ; i++)
				pcarray[i] = 0;
			parray = (short *)&gecudata.TBL09_data[0];
			for( i = 0 ; i < sizeof(gecudata.TBL09_data) / sizeof(short); i++)
				parray[i] = 1000;
			UpdateTable(0, &gecudata);
		}
		else
			memcpy(&gecudata, ((PALLTBL)TBL01_FLASH_ADDRESS  + gsavedata.ncurrent), sizeof(ALLTBL) );
		
		// 臒l̃CfNX쐬
		RemakeThresholdsIdx();
		// Ԃ^C}lɕϊ
		guINJDeadtime = GetTCntFrom10usec(gsavedata.nInjDeadTime);
	}
	
}

//-------------------------------------  Onh
void _general_exception_handler( unsigned long ulCause, unsigned long ulStatus )
{
	/* This overrides the definition provided by the kernel.  Other exceptions 
	should be handled here. */
	//SoftReset();  
//	SetErrorCode(ulStatus);
	
	while(1)
	{
		DelayMs(100);
			led1_on();
		DelayMs(100);
			led1_off();
	}
	
}


void main()
{
	// 
	InitializeSystem();

	// C͒ʐMvZX
	while(1)
	{
//		if((gn100msCnt & 7) < ledBlinkRatio) 
//			led1_on();
//		else
//			led1_off();
		
		// G[ffōs
		// ʐMvZX
		if(isRXINT())
		{
			CommProcess();
			RXINT_Clear();
		}
	}
}
